<template>
  <ms-modal
    :v-model="vModel"
    :id="GLOBALS.__APP_NAME__ + '-add-source-modal'"
    :title="$h.capitalize($t(`${GLOBALS.__T_PREFIX__}.modals.addSource.title`))"
    :ok="ok"
    :ok-title="$h.capitalize($t(`${GLOBALS.__T_PREFIX__}.modals.addSource.okTitle`))"
    :ok-state="isValid"
    :cancel="cancel"
    :cancel-title="$h.capitalize($t(`global.cancel`))"
    :hide-buttons="!showModalContent"
    @ok="$emit('ok')"
    @cancel="$emit('cancel')"
  >
    <transition
      mode="out-in"
      enter-active-class="animated fadeIn fast"
      leave-active-class="animated fadeOut fast"
    >
      <div :id="GLOBALS.__APP_NAME__ + '-add-source-modal'" v-if="showModalContent" key="modal-content">
        <b-form class="mb-3">
          <!-- Category label -->
          <label for="add-source-select-category">{{ $t(`${GLOBALS.__T_PREFIX__}.global.category`) | capitalize }}:</label>
          <!-- Category select -->
          <v-select
            :placeholder="$h.capitalize($t('global.choose'))"
            label="label"
            v-model="newFeed.category_id"
            :reduce="category => category.id"
            :options="categories"
            class="mb-2"
          />
          <!-- Label input -->
          <b-form-group
            id="input-group-label"
            :label="$h.capitalize($t(`${GLOBALS.__T_PREFIX__}.global.label`) + ':')"
            label-for="add-source-input-label"
          >
            <b-form-input
              v-model="newFeed.label"
              id="add-source-input-label"
              type="text"
              :state="labelState"
              required
              placeholder="Label"
              class="ms_input mb-2"
            />
          </b-form-group>
          <!-- URL input -->
          <b-form-group
            id="input-group-url"
            label="URL:"
            label-for="add-source-input-url"
          >
            <!--
              Input: note that debounce is activated
              v-model is updated after 3000ms on key up/change
            -->
            <b-form-input
              v-model="newFeed.url"
              id="add-source-input-url"
              type="text"
              :state="urlState"
              required
              placeholder="https://"
              class="ms_input"
              debounce="2000"
            />
          </b-form-group>
          <!-- URL validation message -->
          <div v-if="isParsingUrl">
            <p>{{ $t(`${GLOBALS.__T_PREFIX__}.modals.addSource.checkUrlMessage`) }}</p>
          </div>
          <div v-if="!isParsingUrl && newFeed.validSource">
            <p>{{ newFeed.validSource.title }} ({{ newFeed.validSource.feedUrl }})</p>
          </div>
          <div v-if="!isParsingUrl && !newFeed.validSource && newFeed.url.length > 0">
            <p>{{ $t(`${GLOBALS.__T_PREFIX__}.modals.addSource.notFoundMessage`) }}</p>
          </div>
          <div v-if="!isParsingUrl && newFeed.url.length === 0">
            <p>{{ $t(`${GLOBALS.__T_PREFIX__}.modals.addSource.pleaseEnterUrlMessage`) }}</p>
          </div>
        </b-form>
      </div>
      <div v-else key="modal-loading">
        <icon-basic-load width="28" height="28"/>
        <span>{{ $t("global.loading") }}</span>
      </div>
    </transition>
  </ms-modal>
</template>

<script>
import { BaseComponent } from '@/utils/'

export default {
  extends: BaseComponent,
  data () {
    return {
      newFeed: {
        label: '',
        url: '',
        category_id: this.category ? this.category.id : null,
        validSource: false // Define if url is valid
      },
      isParsingUrl: false
    }
  },
  computed: {
    categoryState: function () {
      return this.newFeed.category_id
    },
    labelState: function () {
      return this.newFeed.label.length > 0
    },
    urlState: function () {
      return this.newFeed.validSource !== false
    },
    isValid: function () {
      if (this.categoryState && this.labelState && this.urlState) {
        return true
      } else {
        return false
      }
    },
    showModalContent: function () {
      return !this.feedsCreating
    }
  },
  props: {
    // V-Model: to show the modal
    vModel: {
      type: Boolean,
      default: false
    },
    // Category object
    category: Object
  },
  methods: {
    ok: async function () {
      const newFeed = await this.createFeeds({
        label: this.newFeed.label,
        url: this.newFeed.validSource.feedUrl,
        category_id: this.newFeed.category_id
      })
      if (newFeed instanceof Error) {
        return false
      }
      // Add new feed to store data
      const feeds = this.feeds
      feeds.push(newFeed)
      this.SET_FEEDS(feeds)
      // Load data
      this.loadFeedData(newFeed.id)
      return true
    },
    cancel: function () {
      return true
    }
  },
  state: {
    MyFeedsModule: [
      'feeds',
      'categories',
      'feedsCreating',
      'parser',
      'corsProxy'
    ]
  },
  actions: {
    MyFeedsModule: [
      'createFeeds',
      'loadFeedData'
    ]
  },
  mutations: {
    MyFeedsModule: [
      'SET_FEEDS'
    ]
  },
  watch: {
    category: function (to, from) {
      this.newFeed.category_id = this.category ? this.category.id : null
    },
    'newFeed.url': async function (to, from) {
      this.newFeed.validSource = false
      this.isParsingUrl = true
      // If url valid
      if (this.$h.isValidHttpUrl(to) instanceof URL) {
        try {
          const data = await this.parser.parseURL(this.corsProxy + this.newFeed.url)
          this.newFeed.validSource = data
        } catch (error) {
          this.newFeed.validSource = false
        }
      }
      this.isParsingUrl = false
    }
  }
}
</script>
